
/* apache-json-cfl-log-transformer:

    A JSON-based Apache Common Log Format Kinesis Transformer. This consumes
    JSON generated by the Amazon Kinesis Agent's LOGTOJSON and APACHECOMMONLOG
    data processing options. This pushes some of the log parsing and encoding
    work out to the log publishers (which may or may not be desirable depending
    upon the use case). This probably isn't an overall performance win: we
    could just pass raw Apache logs in and do all of the parsing here.

    The decision to do things this way had four motivations: (i) to avoid
    nearly copying the AWS-provided Lambda blueprint; (ii) to use what looked
    like a slightly-better engineered and more flexible log parsing system
    in the Kinesis Agent, supporting additional formats and a parser API;
    (iii) to provide a stream that spoke JSON natively for interoperability
    and/or flexibility; and (iv) to learn/demonstrate the ability to directly
    customize pieces of AWS agent/client software when necessary.
*/

'use strict';

/**
 * @name scrub_iso_date_string
 */
const scrub_iso_date_string = (_str) => {

  return _str.replace(/\.[\d]+Z\s*$/, '').replace('T', ' ');
};

/**
 * @name timestamp_to_utc
 */
const timestamp_to_utc = (_str) => {

  return scrub_iso_date_string(
    (new Date(_str.replace(/(\/\d{4}):/, (_m, _d) => `${_d} `))).toISOString()
  );
};

/**
 * @name timestamp_utc_offset
 */
const timestamp_utc_offset = (_str) => {

  const m = _str.match(/.*\s+[-\+](\d{3,4})/);
  return (m[1] != null ? parseInt(m[1], 10) : null);
};

/**
 * @name http_request_parse
 */
const http_request_parse = (_str) => {

  const m = _str.match(/^([A-Z]+)\s+(.*)\s+([A-Z]+\/[\d\.]+)/);
  return (m != null ? { method: m[1], path_query: m[2], protocol: m[3] } : {});
};

/**
 * @name transform_object
 */
const transform_object = (_o) => {

  _o.timestamp_utc = timestamp_to_utc(_o.datetime);
  _o.timestamp_utc_offset = timestamp_utc_offset(_o.datetime);
  _o.processed_at = scrub_iso_date_string((new Date()).toISOString());

  Object.assign(_o, http_request_parse(_o.request))
};

/**
 * @name handler
 */
exports.handler = (_ev, _ctx, _cb) => {

  const charset = 'utf8';
  const encoding = 'base64';

  const output = _ev.records.map((_r) => {
    try {
      /* Deserialization overhead */
      let object = JSON.parse(
        Buffer.from(_r.data, encoding)
      );

      /* Actual work happens here */
      transform_object(object);

      /* Serialization overhead */
      const rv = Buffer.from(
        JSON.stringify(object) + "\n", charset
      ).toString(encoding);

      /* Success */
      return {
        result: 'Ok',
        recordId: _r.recordId, data: rv
      };
    } catch (_e) {
      /* Rapid unscheduled disassembly */
      return {
        result: 'ProcessingFailed',
        recordId: _r.recordId, data: _r.data
      };
    }
  });

  /* Yield results back to Lambda */
  _cb(null, { records: output });
};

